<script setup lang="ts">
// ----------------------------------------------------------------
// Import
// ----------------------------------------------------------------

import { useConnectionStore } from "@/stores/useConnectionStore";
import { useSubmissionStore } from "@/stores/useSubmissionStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";

// ----------------------------------------------------------------
// Variables
// ----------------------------------------------------------------

const submissionStore = useSubmissionStore();
const workspaceStore = useWorkspaceStore();
const connectionStore = useConnectionStore();
const route = useRoute();

const submissionParametersDialog = ref(false);
const title = ref("General");
const currentConnection = ref(null);

const menu = [
  {
    title: "General",
    icon: "mdi-cog-outline",
  },
  {
    title: "Settings",
    icon: "mdi-tune-variant",
  },
  {
    title: "Members",
    icon: "mdi-account-multiple-outline",
  },
  {
    title: "Connection",
    icon: "mdi-transit-connection-variant",
  },
];

// ----------------------------------------------------------------
// Lifecycle
// ----------------------------------------------------------------

onMounted(async () => {
  workspaceStore.currentWSlug = route.params.wslug;
  submissionStore.currentSubid = route.params.subid;
  await fetchData();
});

// ----------------------------------------------------------------
// Functions
// ----------------------------------------------------------------

// The above code is defining an asynchronous function called `fetchData`. Inside this
// function, it first calls the `fetchNodes` method of the `submissionStore` object, which is
// expected to be an asynchronous operation. It uses the `await` keyword to wait for this
// operation to complete before moving on to the next line.
async function fetchData() {
  await workspaceStore.fetchWorkspaces();
  await workspaceStore.fetchWorkspaceMembers();

  await connectionStore.fetchConnections();

  await submissionStore.fetchSubmissions();

  currentConnection.value = connectionStore.getConnection(
    submissionStore.currentSubmission.connectionID,
  );
}
</script>

<template>
  <v-btn
    height="40px"
    :disabled="submissionStore.isLocked"
    @click="submissionParametersDialog = true"
  >
    {{ $t("parameters") }}
  </v-btn>

  <v-dialog
    v-model="submissionParametersDialog"
    width="100%"
    height="100%"
    style="max-width: 1150px !important; max-height: 850px"
    @update:submission-parameters-dialog="submissionParametersDialog = $event"
  >
    <v-card class="ma-0 pa-0 fill-height">
      <v-card-text class="ma-0 pa-0 fill-height">
        <v-row class="fill-height ma-0">
          <v-col style="max-width: 240px !important; height: 100%" class="bgGray">
            <p class="font-weight-bold">
              Submission Parameters
            </p>
            <v-list class="bgGray">
              <template v-for="(m, index) in menu" :key="index">
                <v-list-item
                  :value="m.title"
                  :active="title === m.title"
                  :class="{ 'primary--text': title === m.title }"
                  @click="title = m.title"
                >
                  <v-list-item-title class="d-flex align-center">
                    <v-icon class="me-3">
                      {{ m.icon }}
                    </v-icon>
                    <p>{{ m.title }}</p>
                  </v-list-item-title>
                </v-list-item>
              </template>
            </v-list>
          </v-col>
          <v-col style="width: calc(100%-240px); height: 100%; overflow: auto">
            <SubmissionParametersGeneral v-if="title === 'General'" />
            <SubmissionParametersSettings v-if="title === 'Settings'" />
            <SubmissionParametersMembers v-if="title === 'Members'" />
            <SubmissionParametersConnection
              v-if="title === 'Connection'"
              :connection-id="submissionStore.currentSubmission.connectionID"
            />
          </v-col>
        </v-row>
      </v-card-text>
    </v-card>
  </v-dialog>
</template>

<style>
.bgGray {
  background: rgb(var(--v-theme-background-gray));
}
</style>
